import { Atom, WritableAtom, AnyAtom } from './types';
import { ImmutableMap } from './immutableMap';
declare type Revision = number;
export declare type AtomState<Value = unknown> = {
    readE?: Error;
    readP?: Promise<void>;
    writeP?: Promise<void>;
    value?: Value;
    rev: Revision;
    deps: Map<AnyAtom, Revision>;
};
export declare type State = ImmutableMap<AnyAtom, AtomState>;
export declare type Actions = {
    add: <Value>(id: symbol, atom: Atom<Value>) => void;
    del: <Value>(id: symbol, atom: Atom<Value>) => void;
    read: <Value>(state: State, atom: Atom<Value>) => AtomState<Value>;
    write: <Value, Update>(atom: WritableAtom<Value, Update>, update: Update) => void | Promise<void>;
};
export declare const getContexts: (scope?: string | number | symbol | undefined) => readonly [import("use-context-selector").Context<Actions | null>, import("use-context-selector").Context<ImmutableMap<Atom<unknown>, AtomState<unknown>> | null>];
export {};
